package decorators;

import javax.decorator.Decorator;
import javax.decorator.Delegate;
import javax.inject.Inject;

@Decorator
public abstract class CalculatorDecorator implements Calculator {

    @Inject @Delegate private Calculator calculator;

    @Override
    public int add(int a, int b) {
        System.out.println("add(a,b) DECORATED");
        return calculator.add(a, b);
    }

    @Override
    public int subtract(int a, int b) {
    	System.out.println("subtract(a,b) DECORATED");
        return calculator.subtract(a, b);
    }

    @Override
    public int multiply(int a, int b) {
    	System.out.println("multiply(a,b) DECORATED");
        return calculator.multiply(a, b);
    }

    @Override
    public int divide(int a, int b) {
    	System.out.println("divide(a,b) DECORATED");
        return calculator.divide(a, b);
    }
}
