package decorators.test;

import junit.framework.TestCase;

import javax.ejb.EJB;
import javax.ejb.embeddable.EJBContainer;

import decorators.Calculator;

public class CalculatorTest extends TestCase {

    @EJB
    private Calculator calculator;

    /**
     * Bootstrap the Embedded EJB Container
     *
     * @throws Exception
     */
    protected void setUp() throws Exception {
        EJBContainer.createEJBContainer().getContext().bind("inject", this);
    }

    public void test() {

        assertEquals(10, calculator.add(4, 6));
        assertEquals(24, calculator.multiply(4, 6));
        assertEquals(2, calculator.divide(12, 6));
        assertEquals(4, calculator.remainder(46, 6));
    }
}
